#include <QStringList>
#include <iostream>

#include "inputArgumentParser.h"
#include "modelParameters.h"

inputArgumentParser::inputArgumentParser()
{
}

// Parse command line args
std::shared_ptr<modelParameters> inputArgumentParser::createModelParams(QStringList & inArgs)
{
    std::shared_ptr<modelParameters> returnParams(new modelParameters());
    int nArgs = inArgs.length();

    // Traverse all the input args
    for (int i=1; i<nArgs; i++)
    {

        // dataFilename
        if (!qstrcmp(inArgs[i].toStdString().c_str(), "-df"))
        {
            i++;
            returnParams->setDataFilename(inArgs[i]);
        }

        // moving average length 1
        else if (!qstrcmp(inArgs[i].toStdString().c_str(), "-mAvgL1"))
        {
            i++;
            returnParams->setMovingAvgLen1(inArgs[i].toUInt());
        }

        // moving average length 2
        else if (!qstrcmp(inArgs[i].toStdString().c_str(), "-mAvgL2"))
        {
            i++;
            returnParams->setMovingAvgLen2(inArgs[i].toUInt());
        }

        // Unknown arguments
        else {
            std::cerr << "Unknown argument: " << inArgs[i].toStdString() << std::endl;
        }
    }
    return returnParams;
}
