#include <iostream>

#include "mainCommandLine.h"
#include "modelParameters.h"
#include "inputArgumentParser.h"
#include "tradingModel.h"

// Constructor
mainCommandLine::mainCommandLine()
{

}

/// Run method
void mainCommandLine::run(QStringList & inputArgs)
{
    //1. Create model params from command line args
    std::unique_ptr<inputArgumentParser> inputArgParser = std::unique_ptr<inputArgumentParser>(new inputArgumentParser());

    //2. Create instance of trading model
    std::unique_ptr<tradingModel> crossOverModel = std::unique_ptr<tradingModel>(new tradingModel());

    //3. Initialize the model
    std::shared_ptr<modelParameters> modelParams = inputArgParser->createModelParams(inputArgs);
    crossOverModel->init(modelParams);

    //4. Run the model
    crossOverModel->run();

    //5. Get statistics
    crossOverModel->printStats();
}
