#ifndef SIMPLEMOVINGAVERAGE_H
#define SIMPLEMOVINGAVERAGE_H

#include <boost/circular_buffer.hpp>
#include <memory>

// Semi efficient quick moving average class

class simpleMovingAverage
{
public:
    simpleMovingAverage(unsigned);

    void addDataPoint(double d);

    void addDataPoint(int i);

    double getCurrentValue();

    bool calcSimple();
    bool calcQuick();
    bool spoolSamples();

private:
    std::unique_ptr<boost::circular_buffer<double>> dataPoints_;
    unsigned mAvgLength_;
    unsigned numDataPointsRead_;
    double currentValue_;
};

#endif // SIMPLEMOVINGAVERAGE_H
