#ifndef STOCKPORTFOLIO_H
#define STOCKPORTFOLIO_H

// Portfolio class to help manage a stock portfolio consisting of shares of one stock at a time

class stockPortfolio
{
public:
    stockPortfolio(double);

    // Buy / Sell
    void doBuy(double,unsigned int);
    void doSell(double);

    // Update with most recent underlying price
    void update(double inPrice);

    // Basic Values
    double getCashValue();
    unsigned getNumShares();
    double getInvestedValue();
    double getTotalValue();
    double getStartValue();
    unsigned getNumSellTrades();
    unsigned getNumTradesPos();
    unsigned getNumTradesNeg();
    double getMinValue();
    double getMaxValue();

private:
   // Main elements
    double startAmount_;
    double cashAmount_;
    double investedValue_;
    double totalValue_;
    double minValue_;
    double maxValue_;
    unsigned numShares_;
    unsigned numSells_;
    unsigned numTradesPos_;
    unsigned numTradesNeg_;
    double buyPrice_;
    double sellPrice_;
};

#endif // STOCKPORTFOLIO_H
