#ifndef TRADINGMODEL_H
#define TRADINGMODEL_H

#include <memory>

#include "priceDataSet.h"
#include "stockPortfolio.h"

class modelParameters;

// Trading model class that executes trading logic for a crossover based strategy

// Enum for trade state machine
enum TRADE_STATE {
    SOLD = 0,
    SELL = 1,
    BOUGHT = 2,
    BUY = 3
};

// Class definition
class tradingModel
{
public:

    tradingModel();
    void test();

    // Steps 3-5 of the basic paradigm
    bool init(std::shared_ptr<modelParameters>);
    void run();
    void printStats();

private:

    // We will use these internally
    bool loadPriceData();
    void setTradeState(TRADE_STATE);
    TRADE_STATE getTradeState();

    TRADE_STATE tradeState_;

    std::shared_ptr<modelParameters> modelParams_;
    std::unique_ptr<priceDataSet> priceData_;

    unsigned movingAvgLen1_;
    unsigned movingAvgLen2_;

    std::unique_ptr<stockPortfolio> modelPortfolio_;

};

#endif // TRADINGMODEL_H
